package org.apache.commons.beanutils.converters;

import java.sql.Time;
import org.apache.commons.beanutils.ConversionException;
import org.apache.commons.beanutils.Converter;

public final class SqlTimeConverter implements Converter {
  private Object defaultValue;
  
  private boolean useDefault;
  
  public SqlTimeConverter() {
    this.defaultValue = null;
    this.useDefault = true;
    this.defaultValue = null;
    this.useDefault = false;
  }
  
  public SqlTimeConverter(Object defaultValue) {
    this.defaultValue = null;
    this.useDefault = true;
    this.defaultValue = defaultValue;
    this.useDefault = true;
  }
  
  public Object convert(Class type, Object value) {
    if (value == null) {
      if (this.useDefault)
        return this.defaultValue; 
      throw new ConversionException("No value specified");
    } 
    if (value instanceof Time)
      return value; 
    try {
      return Time.valueOf(value.toString());
    } catch (Exception e) {
      if (this.useDefault)
        return this.defaultValue; 
      throw new ConversionException(e);
    } 
  }
}
